"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var llmprompts_1 = __importDefault(require("./llmprompts"));
var utils_1 = __importDefault(require("./utils"));
var AIDapter = (function () {
    function AIDapter(llmConfig) {
        this.utils = new utils_1.default();
        this.llm = {
            "app_name": "",
            "provider": "OpenAI",
            "model_name": "",
            "endpoint": "",
            "authentication": {
                "api_key": "",
                "org_id": ""
            },
            "temperature": 0.8,
            "telemetry": true
        };
        this.llm.app_name = llmConfig.app_name || this.llm.app_name;
        this.llm.provider = llmConfig.provider || this.llm.provider;
        if (this.llm.provider == "OpenAI") {
            this.llm.model_name = llmConfig.model_name || "gpt-3.5-turbo-0125";
            this.llm.endpoint = llmConfig.endpoint || "https://api.openai.com/v1/chat/completions";
        }
        else if (this.llm.provider == "GoogleAI") {
            this.llm.model_name = llmConfig.model_name || "gemini-pro";
            this.llm.endpoint = llmConfig.endpoint || "https://generativelanguage.googleapis.com/v1/models/gemini-pro:generateContent";
        }
        else if (this.llm.provider == "ClaudeAI") {
            this.llm.model_name = llmConfig.model_name || "claude-3-haiku-20240307";
            this.llm.endpoint = llmConfig.endpoint || "https://api.anthropic.com/v1/messages";
        }
        this.llm.authentication.api_key = llmConfig.authentication.api_key || this.llm.authentication.api_key;
        this.llm.authentication.org_id = llmConfig.authentication.org_id || this.llm.authentication.org_id;
        this.llm.temperature = llmConfig.temperature || this.llm.temperature;
        this.llm.telemetry = llmConfig.telemetry || this.llm.telemetry;
        this.utils.initializeTelemetry(this.llm.app_name, this.llm.telemetry == true);
    }
    ;
    AIDapter.prototype.getRealtimeSources = function (input, apiRepository) {
        var _this = this;
        var runtimeStart = new Date().getTime();
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var llmPrompts, prompt, resp, llmResponse, payload, _a, llmResponseObject;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.utils.trackEvent(this.llm.app_name, 'question', { question: input }, this.llm.telemetry == true);
                        llmPrompts = new llmprompts_1.default();
                        prompt = llmPrompts.forRealtimeSources(input, apiRepository);
                        resp = {};
                        llmResponse = {};
                        payload = {};
                        _a = this.llm.provider;
                        switch (_a) {
                            case "OpenAI": return [3, 1];
                            case "GoogleAI": return [3, 3];
                            case "ClaudeAI": return [3, 5];
                        }
                        return [3, 7];
                    case 1:
                        this.llm['temperature'] = 0.33;
                        return [4, this.utils.callOpenAI(this.llm, prompt)];
                    case 2:
                        resp = _b.sent();
                        llmResponse = resp.data.choices ? resp.data.choices[0].message.content : {};
                        this.utils.trackUsage(this.llm.app_name, 'openai_calls', 1, this.llm.telemetry == true);
                        return [3, 7];
                    case 3:
                        this.llm['temperature'] = 0.33;
                        return [4, this.utils.callGoogleAI(this.llm, prompt)];
                    case 4:
                        resp = _b.sent();
                        llmResponse = resp.data.candidates ? resp.data.candidates[0].content.parts[0].text : {};
                        this.utils.trackUsage(this.llm.app_name, 'googleai_calls', 1, this.llm.telemetry == true);
                        return [3, 7];
                    case 5:
                        this.llm['temperature'] = 0.33;
                        return [4, this.utils.callClaudeAI(this.llm, prompt)];
                    case 6:
                        resp = _b.sent();
                        llmResponse = resp.data.content ? resp.data.content[0].text : {};
                        this.utils.trackUsage(this.llm.app_name, 'claudeai_calls', 1, this.llm.telemetry == true);
                        return [3, 7];
                    case 7:
                        ;
                        llmResponseObject = llmResponse.substring(llmResponse.indexOf('{'), llmResponse.lastIndexOf('}') + 1);
                        payload = llmResponseObject ? JSON.parse(llmResponseObject) : {};
                        payload['provider'] = this.llm.provider;
                        if (!payload['api_endpoints'])
                            payload['api_endpoints'] = [];
                        payload.api_endpoints.forEach(function (api_endpoint, i) {
                            var placeholdersUndetermined = [];
                            if (!api_endpoint['placeholders'])
                                payload['placeholders'] = [];
                            api_endpoint.placeholders.forEach(function (placeholder) {
                                if (!placeholder.determined)
                                    placeholdersUndetermined.push(placeholder.placeholder);
                            });
                            api_endpoint['undetermined'] = placeholdersUndetermined;
                            if (!api_endpoint['status']) {
                                if (placeholdersUndetermined.length)
                                    api_endpoint['status'] = "NOT-OK";
                                else
                                    api_endpoint['status'] = "OK";
                            }
                            _this.utils.log("I", "API identified: " + api_endpoint.api.url.split('//')[1].split('/')[0], { "status": api_endpoint.status, "placeholders": api_endpoint.placeholders });
                        });
                        payload['runtime'] = Math.round((new Date().getTime() - runtimeStart) / 1000) + " seconds";
                        this.utils.trackUsage(this.llm.app_name, 'apis_identified', payload.api_endpoints.length, this.llm.telemetry == true);
                        resolve(payload);
                        return [2];
                }
            });
        }); });
    };
    ;
    AIDapter.prototype.getDataFromRealtimeSource = function (input, apiRepository, dataConfig) {
        var _this = this;
        var runtimeStart = new Date().getTime();
        return new Promise(function (resolve, reject) {
            var inprogress = true;
            var updatedInput = _this.utils.reformatInput(dataConfig, input);
            _this.getRealtimeSources(updatedInput, apiRepository)
                .then(function (payload) {
                var apiResults = [];
                payload.api_endpoints.forEach(function (api_endpoint, i) {
                    if (api_endpoint.status == "OK") {
                        _this.utils.callAPI(api_endpoint.api.method, api_endpoint.api.url, api_endpoint.api.headers, api_endpoint.api.data || false)
                            .then(function (resp) {
                            var response = resp.data;
                            var maxRecords = ((dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_records) && (dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_records) > 0) ? ((dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_records) > 10 ? 10 : dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_records) : 10;
                            Object.keys(response).forEach(function (key) {
                                if (Array.isArray(response[key])) {
                                    response[key].splice(maxRecords);
                                }
                            });
                            _this.utils.log("I", "[" + resp.status + "] API call ended (" + api_endpoint.api.url.split('//')[1].split('/')[0] + ")");
                            _this.utils.trackUsage(_this.llm.app_name, 'api_calls:' + resp.status, 1, _this.llm.telemetry == true);
                            _this.utils.trackUsage(_this.llm.app_name, 'https://' + api_endpoint.api.url.split('//')[1].split('/')[0], 1, _this.llm.telemetry == true);
                            apiResults.push({ "api_sources": api_endpoint.api.url.split('//')[1].split('/')[0], "data": response });
                            if (apiResults.length == payload.api_endpoints.length)
                                inprogress = false;
                        }).catch(function (err) {
                            _this.utils.log("E", api_endpoint.api.url.split('//')[1].split('/')[0], err.data);
                            _this.utils.trackUsage(_this.llm.app_name, 'api_calls:failed', 1, _this.llm.telemetry == true);
                            apiResults.push({ "api_sources": api_endpoint.api.url.split('//')[1].split('/')[0], "data": {} });
                            if (apiResults.length == payload.api_endpoints.length)
                                inprogress = false;
                        });
                    }
                    else {
                        apiResults.push({ "missing_placeholder_values": api_endpoint.undetermined.join(",") });
                        _this.utils.log("W", "Missing placeholder values: " + api_endpoint.undetermined.join(","));
                        _this.utils.log("W", "[skipping] " + api_endpoint.api.url.split('//')[1].split('/')[0]);
                        _this.utils.trackUsage(_this.llm.app_name, 'api_calls:skipped', 1, _this.llm.telemetry == true);
                        if (apiResults.length == payload.api_endpoints.length)
                            inprogress = false;
                    }
                });
                var timeout = (12 * payload.api_endpoints.length);
                var intvl = setInterval(function () {
                    if (!inprogress || timeout <= 0) {
                        clearInterval(intvl);
                        resolve({
                            "api_results": apiResults,
                            "provider": _this.llm.provider,
                            "runtime": Math.round((new Date().getTime() - runtimeStart) / 1000) + " seconds"
                        });
                    }
                    else
                        timeout--;
                }, 500);
            });
        });
    };
    ;
    AIDapter.prototype.getLLMResponseFromRealtimeSources = function (input, apiRepository, options) {
        var _this = this;
        var runtimeStart = new Date().getTime();
        return new Promise(function (resolve, reject) {
            _this.getDataFromRealtimeSource(input, apiRepository, options === null || options === void 0 ? void 0 : options.dataConfig)
                .then(function (realtimeData) { return __awaiter(_this, void 0, void 0, function () {
                var updatedInput, llmPrompts, prompt, resp, llmResponse, payload_1, _a, llmResponseObject, possibleResponses, possibleResponses;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            updatedInput = "";
                            if (!realtimeData.api_results.length) return [3, 8];
                            if (options) {
                                updatedInput = this.utils.reformatInput(options.dataConfig, input);
                            }
                            llmPrompts = new llmprompts_1.default();
                            prompt = llmPrompts.forResponseWithData(updatedInput, realtimeData.api_results, options === null || options === void 0 ? void 0 : options.agentConfig);
                            resp = {};
                            llmResponse = {};
                            payload_1 = {};
                            _a = this.llm.provider;
                            switch (_a) {
                                case "OpenAI": return [3, 1];
                                case "GoogleAI": return [3, 3];
                                case "ClaudeAI": return [3, 5];
                            }
                            return [3, 7];
                        case 1: return [4, this.utils.callOpenAI(this.llm, prompt)];
                        case 2:
                            resp = _b.sent();
                            llmResponse = resp.data.choices ? resp.data.choices[0].message.content : {
                                "response": "Sorry! Something went wrong that hampered my ablity to respond to your question. Can you rephrase your question and try again?",
                                "status": "NOT-OK",
                                "additional_context": {
                                    "entities": [],
                                    "questions": input
                                }
                            };
                            this.utils.trackUsage(this.llm.app_name, 'openai_calls', 1, this.llm.telemetry == true);
                            return [3, 7];
                        case 3: return [4, this.utils.callGoogleAI(this.llm, prompt)];
                        case 4:
                            resp = _b.sent();
                            llmResponse = resp.data.candidates ? resp.data.candidates[0].content.parts[0].text : {
                                "response": "Sorry! Something went wrong that hampered my ablity to respond to your question. Can you rephrase your question and try again?",
                                "status": "NOT-OK",
                                "additional_context": {
                                    "entities": [],
                                    "questions": input
                                }
                            };
                            this.utils.trackUsage(this.llm.app_name, 'googleai_calls', 1, this.llm.telemetry == true);
                            return [3, 7];
                        case 5: return [4, this.utils.callClaudeAI(this.llm, prompt)];
                        case 6:
                            resp = _b.sent();
                            llmResponse = resp.data.content ? resp.data.content[0].text : {
                                "response": "Sorry! Something went wrong that hampered my ablity to respond to your question. Can you rephrase your question and try again?",
                                "status": "NOT-OK",
                                "additional_context": {
                                    "entities": [],
                                    "questions": input
                                }
                            };
                            this.utils.trackUsage(this.llm.app_name, 'claudeai_calls', 1, this.llm.telemetry == true);
                            return [3, 7];
                        case 7:
                            ;
                            if (resp.status == 200) {
                                this.utils.log("I", "Response OK");
                                llmResponseObject = llmResponse.substring(llmResponse.indexOf('{'), llmResponse.lastIndexOf('}') + 1);
                                payload_1 = llmResponseObject ? JSON.parse(llmResponseObject) : {
                                    "response": llmResponse,
                                    "status": "OK",
                                    "additional_context": {
                                        "entities": [],
                                        "questions": input
                                    }
                                };
                                payload_1.additional_context['data'] = [];
                                payload_1.additional_context['sources'] = [];
                                realtimeData.api_results.forEach(function (result) {
                                    payload_1.additional_context['data'].push(result.data);
                                    payload_1.additional_context['sources'].push(result.api_sources);
                                });
                                this.utils.trackUsage(this.llm.app_name, 'llm_response:' + resp.status, 1, this.llm.telemetry == true);
                                resolve({
                                    "ai_response": payload_1.response,
                                    "ai_status": payload_1.status,
                                    "ai_context": payload_1.additional_context,
                                    "provider": this.llm.provider,
                                    "runtime": Math.round((new Date().getTime() - runtimeStart) / 1000) + " seconds"
                                });
                            }
                            else {
                                this.utils.log("W", "No response - BAD DATA");
                                possibleResponses = [
                                    "I'm sorry, but the data I obtained seems to be invalid. Can you please double-check and rephrase your question?",
                                    "Unfortunately, it appears that the information I looked up isn't insufficient. Could you correct it or provide more details?",
                                    "The data obtained doesn't seem to be reliable. Can you rephrase your question with additional information?",
                                    "It looks like the I obtained to answer your query is incorrect. Could you please provide more information or clarify your question?",
                                    "I'm having trouble with the data I received. Can you check and provide additional information and rephrase your question for better results?"
                                ];
                                this.utils.trackUsage(this.llm.app_name, 'llm_response:' + resp.status, 1, this.llm.telemetry == true);
                                resolve({
                                    "ai_response": possibleResponses[Math.floor(Math.random() * possibleResponses.length)],
                                    "ai_status": "BAD-DATA",
                                    "ai_context": {
                                        "sources": [],
                                        "entities": [],
                                        "questions": input,
                                        "data": []
                                    },
                                    "provider": this.llm.provider,
                                    "runtime": Math.round((new Date().getTime() - runtimeStart) / 1000) + " seconds"
                                });
                            }
                            return [3, 9];
                        case 8:
                            this.utils.log("W", "No APIs identified");
                            possibleResponses = [
                                "I'm sorry, but I couldn't find any information on that topic. Would you mind rephrasing your question and trying again?",
                                "Unfortunately, I couldn't locate any sources relevant to your query. Could you please rephrase and ask again?",
                                "I searched, but couldn't find any available sources for your question. Can you rephrase it to help me assist you better?",
                                "It appears there are no sources available to answer your question. Could you rephrase it so I can try again?",
                                "I couldn't locate a source to provide the information you're looking for. Could you please rephrase your question for better results?"
                            ];
                            this.utils.trackUsage(this.llm.app_name, 'llm_response:skipped', 1, this.llm.telemetry == true);
                            resolve({
                                "ai_response": possibleResponses[Math.floor(Math.random() * possibleResponses.length)],
                                "ai_status": "NO-SOURCE",
                                "ai_context": {
                                    "sources": [],
                                    "entities": [],
                                    "questions": input,
                                    "data": []
                                },
                                "provider": this.llm.provider,
                                "runtime": Math.round((new Date().getTime() - runtimeStart) / 1000) + " seconds"
                            });
                            _b.label = 9;
                        case 9: return [2];
                    }
                });
            }); });
        });
    };
    ;
    return AIDapter;
}());
;
module.exports = AIDapter;
