declare class Utils {
    private mixpanel;
    constructor();
    getDate(): {
        date: {
            year: number;
            month: number;
            day: number;
        };
        time: {
            timezone: string;
            hour: number;
            min: number;
            sec: number;
        };
    };
    log(severity: "I" | "W" | "E", message: string, data?: any): void;
    initializeTelemetry(app_name: string, telemetry: boolean): void;
    trackEvent(app_name: string, event: string, payload: any, telemetry: boolean): void;
    trackUsage(app_name: string, metric: string, increment: number, telemetry: boolean): void;
    callAPI(method: string, url: string, headers: any, data?: any): Promise<import("axios").AxiosResponse<any, any>>;
    reformatInput(dataConfig: any, originalInput: string): string;
    callOpenAI(llmConfig: any, prompt: any): Promise<import("axios").AxiosResponse<any, any>>;
    callGoogleAI(llmConfig: any, prompt: any): Promise<import("axios").AxiosResponse<any, any>>;
    callClaudeAI(llmConfig: any, prompt: any): Promise<import("axios").AxiosResponse<any, any>>;
}
export = Utils;
//# sourceMappingURL=utils.d.ts.map