"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var axios_1 = __importDefault(require("axios"));
var mixpanel_1 = __importDefault(require("mixpanel"));
var Utils = (function () {
    function Utils() {
        this.mixpanel = mixpanel_1.default.init('2efd45db81216e8c85525dee82202bc4');
    }
    Utils.prototype.getDate = function () {
        var dateTimeParts = new Date().toISOString().split('T');
        var dateParts = dateTimeParts[0].split('-');
        var timeParts = dateTimeParts[1].split(':');
        return {
            "date": {
                "year": parseInt(dateParts[0]),
                "month": parseInt(dateParts[1]),
                "day": parseInt(dateParts[2]),
            },
            "time": {
                "timezone": "UTC",
                "hour": parseInt(timeParts[0]),
                "min": parseInt(timeParts[0]),
                "sec": parseInt(timeParts[2].split('.')[0])
            }
        };
    };
    ;
    Utils.prototype.log = function (severity, message, data) {
        var logentry = "AI-DAPTER :: " + "[" + severity + "]: " + message;
        if (data) {
            if (typeof data == "string")
                logentry += "\n>>\t" + data;
            else
                logentry += "\n>>\t" + JSON.stringify(data);
        }
        console.log(logentry);
    };
    ;
    Utils.prototype.initializeTelemetry = function (app_name, telemetry) {
        if (telemetry)
            this.mixpanel.people.set_once(app_name, { $name: app_name, $distinct_id: app_name });
        else
            this.log("W", "Telemetry is turned off");
    };
    ;
    Utils.prototype.trackEvent = function (app_name, event, payload, telemetry) {
        if (telemetry) {
            payload['distinct_id'] = app_name;
            this.mixpanel.track(event, payload);
        }
        else
            this.log("W", "Telemetry is turned off");
    };
    ;
    Utils.prototype.trackUsage = function (app_name, metric, increment, telemetry) {
        if (telemetry)
            this.mixpanel.people.increment(app_name, metric, increment);
        else
            this.log("W", "Telemetry is turned off");
    };
    ;
    Utils.prototype.callAPI = function (method, url, headers, data) {
        var axiosObj = {};
        axiosObj.method = method;
        axiosObj.url = url;
        axiosObj.headers = headers;
        if (data)
            axiosObj.data = data;
        return (0, axios_1.default)(axiosObj);
    };
    ;
    Utils.prototype.reformatInput = function (dataConfig, originalInput) {
        var entities = [];
        var questions = [];
        if (dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.additional_context) {
            var maxContext = ((dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_contexts) && (dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_contexts) > 0) ? ((dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_contexts) > 2 ? 2 : dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.max_contexts) : 2;
            dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.additional_context.splice(0, (dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.additional_context.length) - maxContext);
            dataConfig === null || dataConfig === void 0 ? void 0 : dataConfig.additional_context.forEach(function (context) {
                if (Object.keys(context).length > 0) {
                    if (context.questions)
                        questions.push(context.questions);
                    if (context.entities)
                        entities.push(context.entities);
                }
            });
        }
        questions.push(originalInput);
        var updatedInput = questions.join(" ");
        if (entities.length)
            updatedInput += " (Consider: " + entities.join(' ') + ")";
        return updatedInput;
    };
    ;
    Utils.prototype.callOpenAI = function (llmConfig, prompt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, (0, axios_1.default)({
                        "method": "POST",
                        "url": llmConfig.endpoint,
                        "headers": {
                            "Content-Type": "application/json",
                            "Authorization": "Bearer " + llmConfig.authentication.api_key,
                            "OpenAI-Organization": llmConfig.authentication.org_id
                        },
                        "data": {
                            "model": llmConfig.model_name,
                            "messages": [
                                { "role": "system", "content": prompt.system },
                                {
                                    "role": "user", "content": [
                                        { "type": "text", "text": prompt.context + prompt.task + prompt.format }
                                    ]
                                }
                            ],
                            "temperature": llmConfig.temperature || 0.82
                        }
                    })];
            });
        });
    };
    ;
    Utils.prototype.callGoogleAI = function (llmConfig, prompt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, (0, axios_1.default)({
                        "method": "POST",
                        "url": llmConfig.endpoint + "?key=" + llmConfig.authentication.api_key,
                        "headers": {
                            "Content-Type": "application/json"
                        },
                        "data": {
                            "contents": [{
                                    "parts": [{
                                            "text": prompt.system
                                        },
                                        {
                                            "text": prompt.context
                                        },
                                        {
                                            "text": prompt.task
                                        },
                                        {
                                            "text": prompt.format
                                        }]
                                }],
                            "generationConfig": {
                                "temperature": llmConfig.temperature || 0.82
                            },
                            "safety_settings": [
                                {
                                    "category": "HARM_CATEGORY_SEXUALLY_EXPLICIT",
                                    "threshold": "BLOCK_ONLY_HIGH",
                                },
                                {
                                    "category": "HARM_CATEGORY_HATE_SPEECH",
                                    "threshold": "BLOCK_ONLY_HIGH",
                                },
                                {
                                    "category": "HARM_CATEGORY_HARASSMENT",
                                    "threshold": "BLOCK_ONLY_HIGH",
                                },
                                {
                                    "category": "HARM_CATEGORY_DANGEROUS_CONTENT",
                                    "threshold": "BLOCK_ONLY_HIGH",
                                }
                            ]
                        }
                    })];
            });
        });
    };
    ;
    Utils.prototype.callClaudeAI = function (llmConfig, prompt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, (0, axios_1.default)({
                        "method": "POST",
                        "url": llmConfig.endpoint,
                        "headers": {
                            "Content-Type": "application/json",
                            "X-API-Key": llmConfig.authentication.api_key,
                            "anthropic-version": "2023-06-01"
                        },
                        "data": {
                            "model": llmConfig.model_name,
                            "max_tokens": 4096,
                            "system": prompt.system,
                            "messages": [
                                {
                                    "role": "user", "content": [
                                        { "type": "text", "text": prompt.context + prompt.task + prompt.format }
                                    ]
                                }
                            ],
                            "temperature": llmConfig.temperature || 0.82
                        }
                    })];
            });
        });
    };
    ;
    return Utils;
}());
;
module.exports = Utils;
